<?php
class Commander {

    protected $_files = array(
        'psou_log',
        'psila_log',
        'zsou_log',
        'zsila_log',
        'zruka_log',
    );
    protected $_path = 'reports/';
    protected $_content = array();
    protected $_times = array();
    static $a = 0.00000002; // konstanta pro 2ms prevod;
    

    public function getA() {
        return self::$a;
    }
    
    public function addTime($time, $msg) {
        $this->_times[] = array (
            't' => round($time, 2),
            'm' => $msg,
        );
    }
    
    public function getTimes($type = '') {
        if ($type == 'html') return $this->_getHtmlTimes();
        return $this->_times;
    }
    
    protected function _getHtmlTimes () {
        $html = '';
        $html .= '<ul class="list-group">';
        $sum = 0;
        foreach ($this->_times as $time) {
            $html .= '<li class="list-group-item list-group-item-success"><span class="badge">' . $time['t'] . 's</span>' . $time['m'] . '</li>';
            $sum += $time['t'];
        }
        $html .= '<li class="list-group-item list-group-item-warning"><span class="badge">' . $sum . 's</span>Celkem</li>';
        $html .= '</ul>';
        $html = str_replace('"', '\'', $html);
        return $html;
    }
    
    
    public function getFiles() {
        $f = array();
        foreach ($this->_files as $file) {
            $f[$file] = $this->_path . $file . '.txt';
        }
        return $f;
    }
    
    public function getPath() {
        return $this->_path;
    }
    
    protected $_check = NULL;
    public function checkFiles() {
        if (isset($this->_check)) return $this->_check;
        $ch = TRUE;
        $files = $this->getFiles();
        foreach ($files as $file) {
            if (!file_exists($file)) {
                $ch = FALSE;
                break;
            }
        }
        $this->_check = $ch;
        return $this->_check;
    }
    
    public function processFiles() {
        $start = microtime(TRUE);
        $fs = $this->getfiles();
        $file = 0;
        foreach ($fs as $f) {
            if (!file_exists($f)) continue;
            $h = fopen($f, 'r');
            $i = 0;
            while (($row = fgetcsv($h, 1000, " ")) !== FALSE) {
                $i++;
                if ($i == 2) {
                    $content['spz'] = $row[2];
                    $content['vyrobce'] = iconv('Windows-1250', 'UTF-8', $row[6]);
                    $content['typ'] = iconv('Windows-1250', 'UTF-8', $row[7]);
                    $content['hm'] = $row[9];
                }
                if ($i >= 4) {
                    if (!isset($content[$file])) {
                        $content[$file] = array(
                            'l' => array(),
                            'p' => array(),
                        );
                    }
                    $uk = 'l';
                    if ($row[0] == '1') $uk = 'p';
                    $content[$file][$uk][] = array (
                        't' => $row[1],
                        'im' => $row[2],
                    );
                }
            }
            // data jsou nactena spocitame otacky a zrychleni
            foreach ($content[$file] as $wheel => $datas) {
                $count = count($datas) - 2;
                foreach ($datas as $i => $data) {
                    if ($i == 0) continue;
                    if ($i >= $count) continue;
                    $ot = $this->_getOtacky($datas, $i);
                    //$v = ($ot * 0.25 * pi()) / 60;
                    $ac = ((($this->_getOtacky($datas, $i+1) - $ot) / 60) / (($datas[$i+1]['t'] - $data['t']) * self::$a)) * pi() * 0.24;
                    $content[$file][$wheel][$i] += array (
                        'ot' => $ot,
                        //'v' => $v,
                        'acc' => $ac,
                    );
                }
            }
            $file++;
        }
        $this->_content = $content;
        $this->addtime(microtime(TRUE) - $start, 'Načtení dat');
    }
    
    protected function _getOtacky($data, $i) {
        return (($data[$i+1]['im'] - $data[$i-1]['im']) / 1024 * 60) / (($data[$i+1]['t'] - $data[$i-1]['t']) * self::$a);
    }
    
    public function getContent($file, $wheel = 'both') {
        if (!in_array($file, $this->_files)) return array();
        foreach ($this->_files as $i => $f) {
            if ($f == $file) {
                return ($wheel == 'both') ? $this->_content[$i] : $this->_content[$i][$wheel];
            }
        }
    }
    public function getHmotnost() {
        return $this->getValue('hm');
    }
    
    public function setValue($variable, $value) {
        $this->_content[$variable] = $value;
    }
    
    public function getValue($variable) {
        return $this->_content[$variable];
    }
    
    public function linearInter($x1, $y1, $x2, $y2, $y) {
        return ((($y-$y1)*($x1-$x2)) / ($y1 - $y2) + $x1);
    }
    
    public function getTableData() {
        $d = $this->_content;
        
        $score = 0;
        $score += ($d['avg_symetry_front'] < 30) ? 200 : 0;
        $score += ($d['avg_symetry_back'] < 30) ? 200 : 0;
        $score += (abs(($d['avg_pow_front_l'] - $d['avg_pow_front_p']) / $d['avg_pow_front_p'] * 100) < 30) ? 10 : 0;
        $score += (abs(($d['avg_pow_back_l'] - $d['avg_pow_back_p']) / $d['avg_pow_back_p'] * 100) < 30) ? 10 : 0;
        
        $symetry = ($score < 400) ? 'KO' : 'OK';
        $symetry_cl = ($score < 400) ? 'danger' : (($score < 420) ? 'warning' : 'success');
        $koef_cl =  ($d['avg_power'] > 6) ? 'success' : (($d['avg_power'] < 5.6) ? 'danger' : 'warning');
        
        $ret = array(
            array('Značka', 'Typ', 'RZ', 'Hmotnost', 'Brzdné zpomalení', 'Brzdová soustava je z hlediska souměrnosti'),
            array($d['vyrobce'], $d['typ'], $d['spz'], $d['hm'] . ' kg', '<div class="bg-' . $koef_cl . '">' . round($d['avg_power'],2) . ' m.s<sup>-2</sup></div>', '<div class="bg-' . $symetry_cl . '">' . $symetry . '</div>'),
            array('<strong>Průměrná brzdná síla PL</strong>', '<strong>Průměrná brzdná síla PP</strong>', '<strong>Průměrná brzdná síla ZL</strong>', '<strong>Průměrná brzdná síla ZP</strong>', '<strong>Průměrná brzdná síla soustavy</strong>'),
            array($d['avg_pow_front_l'] . ' N', $d['avg_pow_front_p'] . ' N', $d['avg_pow_back_l'] . ' N', $d['avg_pow_back_p'] . ' N', ($d['avg_pow_front_l'] + $d['avg_pow_front_p'] + $d['avg_pow_back_l'] + $d['avg_pow_back_p']) . ' N'),
        );
        return $ret;
    }
}