<?php
class Power {

    protected $cmd = NULL;
    protected $_data = array();
    protected $_titles = array (
        'front' => 'Brzdná síla přední nápravy',
        'back' => 'Brzdná síla zadní nápravy',
    );
    
    function __construct() {
        global $commander;
        $this->cmd = $commander;
    }
    
    public function processPower() {
        $start = microtime(TRUE);
        $this->_data['front'] = $this->cmd->getContent('psila_log');
        $this->_data['back'] = $this->cmd->getContent('zsila_log');
        
        $sila['fl'] = $this->_getPower('front', 'l');
        $sila['fp'] = $this->_getPower('front', 'p');
        $sila['bl'] = $this->_getPower('back', 'l');
        $sila['bp'] = $this->_getPower('back', 'p');

        foreach ($sila as $uk => $sily) {
            $type = substr($uk,0, 1);
            $wheel = substr($uk, 1, 1);
            $type = ($type == 'f') ? 'front' : 'back';
            foreach ($sily as $i => $sil) {
                $sila[$type][$i][$wheel] = $sil;
            }
        }
        unset ($sila['fp']);unset ($sila['fl']);unset ($sila['bp']);unset ($sila['bl']);
        $this->_data['sila'] = $sila;        
        $this->cmd->addtime(microtime(TRUE) - $start, 'Kalkulace síly');
    }

    public function processAvgPower() {
        $types = array('front', 'back');
        foreach ($types as $type) {
            $data = $this->_data['sila'][$type];
            $avgl = 0;
            $avgp = 0;
            $cc = 0;
            foreach ($data as $pow) {
                $avgl += $pow['l'];
                $avgp += $pow['p'];
                $cc++;
            }
            $avgl = round($avgl/$cc);
            $avgp = round($avgp/$cc);
            $this->cmd->setValue('avg_pow_' . $type . '_l', $avgl);
            $this->cmd->setValue('avg_pow_' . $type . '_p', $avgp);
        }
    }
    
    protected function _getPower($type = 'front', $wheel = 'l') {
        $return = array();
        $count = count($this->_data[$type][$wheel]);
        foreach ($this->_data[$type][$wheel] as $i => $val) {
            if (!isset($this->_data[$type][$wheel][$i-1])) continue;
            $val2 = $this->_data[$type][$wheel][$i-1];
            if (!isset($val['ot']) || !isset($val2['ot'])) continue;
            if ($val['ot'] < 100 && $val2['ot'] >= 100) {
                // udelame si druhy cyklus ktery projde krivku az do dalsiho prekroceni hodnoty 100. Ve vyrezu pak najdeme min(acc)
                $i2 = $i;
                $minAcc = 10000;
                $iMinAcc = 0;
                while ($this->_data[$type][$wheel][$i2]['ot'] < 100) {
                    if ($this->_data[$type][$wheel][$i2]['acc'] < $minAcc) {
                        $minAcc = $this->_data[$type][$wheel][$i2]['acc'];
                        $iMinAcc = $i2;
                    }
                    $i2++;
                    if ($i2 >= $count) break;
                }
                $sum = 0;
                $cc = 0;
                for ($x=$i; $x<=$iMinAcc; $x++) {
                    $sum += $this->_data[$type][$wheel][$x]['acc'];
                    $cc++;
                }
                $avg = $sum/$cc;
                $power = round(((abs($avg) * 185) + 370),0);
                $return[] = $power;
            }
        }
        return $return;
    }
    
    protected function _getWholeBreak($count) {
        return $this->_data['sila']['front'][$count]['l']
        + $this->_data['sila']['front'][$count]['p']
        + $this->_data['sila']['back'][$count]['l']
        + $this->_data['sila']['back'][$count]['p'];
    }

    public function getBrzdovyKoef($count) {
        return $this->_getWholeBreak($count) / $this->cmd->getHmotnost();
    }
       
    public function getTableData() {
        $d = $this->_data['sila'];
        $ret = array(
            array('#', 'Brzdné zpomalení', 'Hodnocení'),
        );
        $avg = 0;
        $i = 0;
        $c = count($d['front']);
        for ($x = 0; $x< $c; $x++) {
            $koef = round($this->getBrzdovyKoef($x),2);
            $stav = ($koef > 6) ? 'překonává' : (($koef < 5.6) ? 'nesplňuje' : 'výrovnává');
            $cl =  ($koef > 6) ? 'success' : (($koef < 5.6) ? 'danger' : 'warning');
            $ret[] = array (
                ++$i,
                $koef . ' m.s<sup>-2</sup>',
                $stav,
                '_cl' => $cl,
            );
            $avg += $this->getBrzdovyKoef($x);
        }
        if ($i > 1) {
            $koef = $avg/$i;
            $this->cmd->setValue('avg_power', $koef);
            $stav = ($koef > 6) ? 'překonává' : (($koef < 5.6) ? 'nesplňuje' : 'výrovnává');
            $cl =  ($koef > 6) ? 'success' : (($koef < 5.6) ? 'danger' : 'warning');
            $ret[] = array(
                'x&#772;',
                round($koef, 2) . ' m.s<sup>-2</sup>',
                $stav,
                '_cl' => $cl,
            );
        }
        return $ret;
    }
    
    
    public function getJs($type) {
        if (!isset($this->_data['sila'][$type])) return '';
        $data = $this->_data['sila'][$type];
        $draw = $data;
        $js = "
    google.setOnLoadCallback(drawPwr" . ucfirst($type) . "Chart);

    function drawPwr" . ucfirst($type) . "Chart() {
      var data = google.visualization.arrayToDataTable([
      ['Měření','Levé kolo','Pravé kolo'],
      ";
      foreach ($draw as $ind => $val) {
            $js .= "['" . ($ind+1) . ".', " . ((isset($val['l'])) ? $val['l'] : '') . ", " . ((isset($val['p'])) ? $val['p'] : '') . "], ";
        }
      $js .="
      ]);


      var options = {
        title: '" . $this->_titles[$type] . "',
        height: 350,
        hAxis: {
          title: 'Měření',
        },
        vAxis: {
            title: 'Brzdná síla (N)',
            format: '# ###',
            gridlines: {count: 5},
            minValue: 0,
        },
        legend: { position: 'none' },
      };

      var chart = new google.visualization.ColumnChart(document.getElementById('chart_pwr_" . $type . "'));
      chart.draw(data, options);
    }";
        return $js;
    }
    
}