<?php
class Symmetry {

    protected $cmd = NULL;
    protected $_data = array();
    protected $_titles = array (
        'front' => 'Průběh brzdné síly přední nápravy',
        'back' => 'Průběh brzdné síly zadní nápravy',
        'hand' => 'Průběh brzdné síly ruční brzdy',
    );
    
    protected $_titles2 = array (
        'front' => 'Souměrnost přední nápravy',
        'back' => 'Souměrnost zadní nápravy',
        'hand' => 'Souměrnost ruční brzdy',
    );

    function __construct() {
        global $commander;
        $this->cmd = $commander;
    }

    public function processSymmetry() {
        $start = microtime(TRUE);
        $this->_data['front'] = $this->cmd->getContent('psou_log');
        $this->_data['back'] = $this->cmd->getContent('zsou_log');
        $this->_data['hand'] = $this->cmd->getContent('zruka_log');
        $nabehy = array();
        $nabehy['fl'] = $this->_getNabeh('front', 'l');
        $nabehy['fp'] = $this->_getNabeh('front', 'p');
        $nabehy['bl'] = $this->_getNabeh('back', 'l');
        $nabehy['bp'] = $this->_getNabeh('back', 'p');
        $nabehy['hl'] = $this->_getNabeh('hand', 'l');
        $nabehy['hp'] = $this->_getNabeh('hand', 'p');
        // Srovnat data predni napravy
        $f = array();
        foreach ($nabehy['fl'] as $i => $nabeh) {
            $f[$i] = array (
                'dif' => (($nabehy['fl'][$i] - $nabehy['fp'][$i]) * $this->cmd->getA()) * 1000, //convert to ms
            );
        }
        $nabehy['front'] = $f;
        unset($nabehy['fl']);unset($nabehy['fp']);

        // Srovnat data zadni napravy
        $f = array();
        foreach ($nabehy['bl'] as $i => $nabeh) {
            $f[$i] = array (
                'dif' => (($nabehy['bl'][$i] - $nabehy['bp'][$i]) * $this->cmd->getA()) * 1000, //convert to ms
            );
        }
        $nabehy['back'] = $f;
        unset($nabehy['bl']);unset($nabehy['bp']);

        // Srovnat data rucni brzdy
        $f = array();
        foreach ($nabehy['hl'] as $i => $nabeh) {
            $f[$i] = array (
                'dif' => (($nabehy['hl'][$i] - $nabehy['hp'][$i]) * $this->cmd->getA()) * 1000, //convert to ms
            );
        }
        $nabehy['hand'] = $f;
        unset($nabehy['hl']);unset($nabehy['hp']);
        $this->_data['nabehy'] = $nabehy;
        $this->cmd->addtime(microtime(TRUE) - $start, 'Kalkulace náběhů');
    }

    protected function _getNabeh($type = 'front', $wheel = 'l') {
        $return = array();
        foreach ($this->_data[$type][$wheel] as $i => $val) {
            if (!isset($this->_data[$type][$wheel][$i+1])) continue;
            $val2 = $this->_data[$type][$wheel][$i+1];
            if (!isset($val['ot']) || !isset($val2['ot'])) continue;
            if ($val['ot'] >= 980 && $val2['ot'] < 980) {
                $return[] = $this->cmd->linearInter($val['t'], $val['ot'], $val2['t'], $val2['ot'], 980);
            }
        }
        return $return;
    }

    public function getTableData($type) {
        $d = $this->_data['nabehy'][$type];
        $ret = array(
            array('#', 'Rozdíl v náběhu brzd', 'Dříve nabíhá'),
        );
        $avg = 0;
        $i = 0;
        foreach ($d as $i => $row) {
            $avg += $row['dif'];
            $ret[] = array (
                $i+1,
                round($row['dif'], 2) . ' ms',
                ($row['dif'] > 0) ? 'levé' : 'pravé',
                '_cl' => ($row['dif'] > 0) ? 'info' : 'danger',
            );
        }
        if ($i > 0) {
            $avg = $avg/($i+1);
            $ret[] = array(
                'x&#772;',
                round($avg, 2) . ' ms',
                ($avg > 0) ? 'levé' : 'pravé',
                '_cl' => ($avg > 0) ? 'info' : 'danger'
            );
        }
        return $ret;
    }
    
    public function processPercentSymmetry() {
        $start = microtime(TRUE);
        $this->_data['percent'] = array (
            'front' => $this->_getSymetry('front'),
            'back' => $this->_getSymetry('back'),
            'hand' => $this->_getSymetry('hand'),
        );
        $this->cmd->addtime(microtime(TRUE) - $start, 'Kalkulace souměrnosti');
    }

    protected function _getSymetry($type = 'front') {
        $wheels = array('l', 'p');
        $lines = array();
        foreach ($wheels as $wheel) {
            $lineIndex = 0;
            $count = count($this->_data[$type][$wheel]);
            foreach ($this->_data[$type][$wheel] as $i => $val) {
                if (!isset($this->_data[$type][$wheel][$i+1])) continue;
                $val2 = $this->_data[$type][$wheel][$i+1];
                if (!isset($val['ot']) || !isset($val2['ot'])) continue;
                if ($val['ot'] >= 980 && $val2['ot'] < 980) {
                    // udelame si druhy cyklus ktery projde krivku az do dalsiho prekroceni hodnoty 980. Ve vyrezu pak najdeme min(ot)
                    $i2 = $i+1;
                    $minOt = 10000;
                    $iMinOt = 0;
                    while ($this->_data[$type][$wheel][$i2]['ot'] < 980) {
                        if ($this->_data[$type][$wheel][$i2]['ot'] < $minOt) {
                            $minOt = $this->_data[$type][$wheel][$i2]['ot'];
                            $iMinOt = $i2-2;
                        }
                        $i2++;
                        if ($i2 >= $count) break;
                    }
                    for ($x=$i; $x<=$iMinOt; $x++) {
                        $lines[$lineIndex][round($this->_data[$type][$wheel][$x]['ot'],2)][$wheel] = $this->_data[$type][$wheel][$x]['acc'];
                    }
                    $lineIndex++;
                }
            }
        }
        foreach ($lines as $i => $line) {
            ksort($lines[$i]);
            $line = $lines[$i];
            $ak = array_keys($line);
            
            $count = count($line);
            $ind = 0;
            foreach ($line as $ot => $point) {
                foreach ($wheels as $w) {
                    if (!isset($point[$w])) {
                        // najit nejblizsi prechozi hodnotu
                        $before = NULL;
                        for ($x=$ind;$x>=0;$x--) {
                            if (isset($line[$ak[$x]][$w])) {
                                $before = $ak[$x];
                                break;
                            }
                        }

                        // najit nejblizsi nasledujici hodnotu
                        $after = NULL;
                        if (isset($ak[$ind+1])) {
                            for ($x=$ind+1;$x<$count;$x++) {
                                if (isset($line[$ak[$x]][$w])) {
                                    $after = $ak[$x];
                                    break;
                                }
                            }
                        }

                        // pokud existuji oba body - linearni interpolace
                        if (!empty($before) && !empty($after)) {
                            $lines[$i][$ot][$w] = $this->cmd->linearInter($line[$before][$w], $before, $line[$after][$w], $after, $ot);
                        }
                        // pokud existuje pouze before jsme na konci listu a doplnujeme posledni znamou hodnotu
                        if (!empty($before) && $after === NULL) {
                            $lines[$i][$ot][$w] = $lines[$i][$before][$w];
                        }
                        // pokud existuje pouze after jsme na zacatku listu a doplnujeme prvni znamou hodnotu
                        if (!empty($after) && $before === NULL) {
                            $lines[$i][$ot][$w] = $lines[$i][$after][$w];
                        }
                    }
                }
                $ind++;
            }
        }
        
        // spocitani procentualni odchylky
        foreach ($lines as $i => $line) {
            $sum = 0;
            $c = 0;
            foreach ($line as $ot=>$point) {
                $percent = round((($point['l'] - $point['p']) / $point['p']) * 100, 2);
                $sum += $percent;
                $c++;
                $lines[$i][$ot]['perc'] = $percent;
            }
            $lines[$i]['_avg'] = $sum/$c;
        }
        return $lines;

    }

    public function getTableDataPercent($type) {
        $d = $this->_data['percent'][$type];
        $ret = array(
            array('#', 'Nesouměrnost kol', 'Vyhovuje'),
        );
        $avg = 0;
        $i = 0;
        foreach ($d as $i => $row) {
            $avg += $row['_avg'];
            $ret[] = array (
                $i+1,
                round($row['_avg'], 2) . ' %',
                (abs($row['_avg']) < 30) ? 'Ano' : 'Ne',
                '_cl' => (abs($row['_avg']) < 30) ? 'success' : 'danger',
            );
        }
        if ($i > 0) {
            $avg = $avg/($i+1);
            $this->cmd->setValue('avg_symetry_' . $type, abs($avg));
            $ret[] = array(
                'x&#772;',
                round($avg, 2) . ' %',
                (abs($avg) < 30) ? 'Ano' : 'Ne',
                '_cl' => (abs($avg) < 30) ? 'success' : 'danger',
            );
        }
        return $ret;
    }

    public function getJs($type) {
        if (!isset($this->_data[$type])) return '';
        $data = $this->_data[$type];
        $draw = array();
        $wheel = 0;
        foreach ($data as $vals) {
            $i = 0;
            foreach ($vals as $val){
                if (!isset($val['ot'])) continue;
                $draw[$i++][$wheel] = round($val['ot'],1);
            }
            $wheel++;
        }
        $js = "
    google.setOnLoadCallback(drawSym" . ucfirst($type) . "Chart);

    function drawSym" . ucfirst($type) . "Chart() {
      var data = new google.visualization.DataTable();
      data.addColumn('number', 'X');
      data.addColumn('number', 'Levé kolo');
      data.addColumn('number', 'Pravé kolo');

      data.addRows([";
      foreach ($draw as $ind => $val) {
            if (!isset($val[0])) $val[0] = 0;
            if (!isset($val[1])) $val[1] = 0;
            $js .= "[$ind, $val[0], $val[1]], ";
        }
      $js .="
      ]);


      var options = {
        title: '" . $this->_titles[$type] . "',
        height: 350,
        hAxis: {
          title: 'Čas',
        },
        vAxis: {
            title: 'Otáčky válců (1/min)',
            minValue: 0,
        },
      };

      var chart = new google.visualization.LineChart(document.getElementById('chart_sym_" . $type . "'));
      chart.draw(data, options);
    }";
        return $js;
    }
    
    public function getJsPercent($type) {
        if (!isset($this->_data['percent'][$type])) return '';
        $uk = (isset($this->_data['percent'][$type][1])) ? 1 : 0 ;
        $data = $this->_data['percent'][$type][$uk]; // vybirame prvni mereni
        unset($data['_avg']);
        $draw = $data;
        $js = "
    google.setOnLoadCallback(drawSymPerc" . ucfirst($type) . "Chart);

    function drawSymPerc" . ucfirst($type) . "Chart() {
      var data = new google.visualization.DataTable();
      data.addColumn('number', 'X');
      data.addColumn('number', 'Levé kolo');
      data.addColumn('number', 'Pravé kolo');
      data.addColumn('number', 'Souměrnost (%)');

      data.addRows([";
      foreach ($draw as $ind => $val) {
          $js .= "[" . $ind . ", " . ((isset($val['l'])) ? round($val['l'], 3) : '') . ", " . ((isset($val['p'])) ? round($val['p'], 3) : '') . ", " . ((isset($val['perc'])) ? round($val['perc'],2) : '') . "], ";
        }
      $js .="
      ]);

      
      var options = {
        title: '" . $this->_titles2[$type] . "',
        height: 350,
        hAxis: {
          title: 'Otáčky za minutu',
          direction: -1
        },
        vAxis: {
            0: {title: 'Zrychlení (m.s<sup>-2</sup>)'},
            1: {title: 'Souměrnost (%)'}
        },
        series: {
          0: {targetAxisIndex: 0},
          1: {targetAxisIndex: 0},
          2: {targetAxisIndex: 1}
        },
      };

      var chart = new google.visualization.LineChart(document.getElementById('chart_sym_percent_" . $type . "'));
      chart.draw(data, options);
    }";
        return $js;
    }
}