<?php
error_reporting(E_ALL);
ini_set('display_errors', TRUE);
ini_set('display_startup_errors', TRUE);

include_once('_commander.php');
include_once('_symmetry.php');
include_once('_power.php');
include_once('_uploader.php');
include_once('_renderer.php');

global $messages;
$messages = array();
global $commander;
$commander = new Commander;

if (isset($_POST['op']) && $_POST['op'] == 'go') {
    $upl = new Uploader;
    if (!$upl->getStatus()) $messages['e'][] = 'Nahrání souborů se nezdařilo';
}

$check = $commander->checkFiles();

if ($check) {
    $commander->processFiles();
    $symmetry = new Symmetry;
    $symmetry->processSymmetry();
    $power = new Power;
    $power->processPower();
    $power->processAvgPower();
    $symmetry->processPercentSymmetry();
    
    $symmetry->getTableDataPercent('front');
    $symmetry->getTableDataPercent('back');
    $symmetry->getTableDataPercent('hand');
    $power->getTableData();
}

?>
<!DOCTYPE html>
<html>
<head>
	<title>Martin Přeučil - diplomová práce</title>
	<meta name="description" content="Diplomka" lang="cs" />
	<meta name="keywords" content="bzdy" />
	<meta name="author" content="Martin Přeučil" />
	<meta name="robots" content="all" />
	<meta http-equiv="content-language" content="cs" />
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta charset="utf-8">
    <script src="//ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js"></script>
    <!-- Latest compiled and minified JavaScript -->
    <script src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.2/js/bootstrap.min.js"></script>
<?php if ($check):?>
    <script type="text/javascript" src="//www.google.com/jsapi?autoload={'modules':[{'name':'visualization','version':'1','packages':['corechart']}]}"></script>
<?php endif;?>
    <script src="brake.js"></script>
    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.2/css/bootstrap.min.css">
    <link href="brake.css" rel="stylesheet" type="text/css" media="screen" />
</head>

<body class="html front col-md-12">
<div class="row">
    <header id="header" class="bs-docs-header">
    </header>
</div>
<?php
    if (!empty($messages)) {
        renderMsgs($messages);
    }
?>
<div class="container bs-docs-container">
    <div class="row">
        <div class="col-md-12" id = "main" role="main">
            <div class="row text-right top-menu">
                <?php if($check):?>
                    <nav>
                    <button type="button" class="btn btn-success" onclick="$('#infoModal').modal()"><div><span class="glyphicon glyphicon-info-sign" aria-hidden="true"></span>&nbsp;info</div></button>
                    <button type="button" class="btn btn-warning trail">Výpočet brzdné dráhy</button>
                    <button type="button" class="btn btn-primary detail">Detailní zpráva o stavu brzrdné soustavy</button>
                    <button type="button" class="btn btn-info upload-new">Nahrát nové soubory pro zpracování</button>
                    </nav>
                <?php endif;?>
            </div>
            <div class="main-form <?php if ($check) echo 'hide';?>">
            <form  role="form" method="post" enctype="multipart/form-data">
                <div class="form-group"></div>
                <div class="form-group col-md-4 text-right">
                    <div class="form-group">
                        <label class="control-label" for="psou_log">Přední náprava (souměrnost)</label>
                        <input type="file" id="psou_log" name="psou_log">
                    </div>
                    <div class="form-group bot">
                        <label class="control-label" for="zsou_log">Zadní náprava (souměrnost)</label>
                        <input type="file" id="zsou_log" name="zsou_log">
                    </div>
                </div>
                <div class="form-group col-md-4">
                    <div id="car"></div>
                </div>
                <div class="form-group col-md-4 text-left">
                    <div class="form-group">
                        <label class="control-label" for="psila_log">Přední náprava (síla)</label>
                        <input type="file" id="psila_log" name="psila_log">
                    </div>
                    <div class="form-group bot">
                        <label class="control-label" for="zsila_log">Zadní náprava (síla)</label>
                        <input type="file" id="zsila_log" name="zsila_log">
                    </div>
                </div>
                <div class="form-group col-md-12 text-center">
                    <div class="form-group">
                        <label class="control-label" for="zruka_log">Ruční brzda</label>
                        <input type="file" id="zruka_log" name="zruka_log">
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-md-offset-10 col-md-2">
                        <input type="hidden" name="op" value="go" />
                        <button type="submit" class="btn btn-primary">Nahrát</button>
                    </div>
                </div>
            </form>
            </div>
            <?php if ($check):?>
            <div class="row detail-pane">
                <!--grahps -->
                <div class="well clearfix panel">
                    <h2>Informace o vozidle</h2>
                    <div class="col-xs-12 col-md-12">
                        <?php renderTable($commander->getTableData()); ?>
                    </div>
                </div>
                <div class="well clearfix panel">
                    <h2>Brzdné síly</h2>
                    <div id="chart_pwr_front" class="col-xs-12 col-md-4 chart"></div>
                    <div id="chart_pwr_back" class="col-xs-12 col-md-4 chart"></div>
                    <div class="col-xs-12 col-md-4 chart">
                        <?php renderTable($power->getTableData()); ?>
                    </div>
                </div>
                <div class="well clearfix panel">
                    <h2>Přední náprava</h2>
                    <div class="col-xs-12 col-md-6 chart">
                        <div id="chart_sym_front" ></div>
                        <?php renderTable($symmetry->getTableData('front')); ?>
                    </div>
                    <div class="col-xs-12 col-md-6 chart">
                        <div id="chart_sym_percent_front"></div>
                        <?php renderTable($symmetry->getTableDataPercent('front')); ?>
                    </div>
                </div>
                <div class="well clearfix panel">
                    <h2>Zadní náprava</h2>
                    <div class="col-xs-12 col-md-6 chart">
                        <div id="chart_sym_back"></div>
                        <?php renderTable($symmetry->getTableData('back')); ?>
                    </div>
                    <div  class="col-xs-12 col-md-6 chart">
                        <div id="chart_sym_percent_back"></div>
                        <?php renderTable($symmetry->getTableDataPercent('back')); ?>
                    </div>
                </div>
                <div class="well clearfix panel">
                    <h2>Ruční brzda</h2>
                    <div class="col-xs-12 col-md-6 chart">
                        <div id="chart_sym_hand"></div>
                        <?php renderTable($symmetry->getTableData('hand')); ?>
                    </div>
                    <div  class="col-xs-12 col-md-6 chart">
                        <div id="chart_sym_percent_hand"></div>
                        <?php renderTable($symmetry->getTableDataPercent('hand')); ?>
                    </div>
                </div>
            </div>
            <div class="row trail-pane hide">
            <form id="trail-form" class="form-horizontal">
                <div class="form-group required">
                    <label for="mass" class="col-sm-3 control-label">Celková hmotnost vozidla (kg):</label>
                    <div class="col-sm-9">
                        <input type="number" min="0" class="form-control" name="mass" id="mass" value="<?php echo $commander->getHmotnost();?>">
                    </div>
                </div>
                <div class="form-group required">
                    <label for="koef" class="col-sm-3 control-label">Součinitel odporu vzduchu:</label>
                    <div class="col-sm-9">
                        <input type="number" min="0"  step="0.01" class="form-control" name="koef" id="koef" placeholder="Součinitel odporu vzduchu">
                    </div>
                </div>
                <div class="form-group required">
                    <label for="glass" class="col-sm-3 control-label">Čelní plocha vozidla (m</sup>2</sup>):</label>
                    <div class="col-sm-9">
                        <input type="number" min="0" step="0.1" class="form-control" name="glass" id="glass" placeholder="Čelní plocha vozidla">
                    </div>
                </div>
                <div class="form-group required">
                    <label for="depth" class="col-sm-3 control-label">Hloubka dezénu (mm):</label>
                    <div class="col-sm-9">
                        <input type="number" min="0" step="0.01" max="9" class="form-control" name="depth" id="depth" value="5" placeholder="Hloubka dezénu">
                    </div>
                </div>
                <div class="form-group">
                    <label for="skew" class="col-sm-3 control-label">Sklon svahu (%):</label>
                    <div class="col-sm-9">
                        <input type="number" min="-100" max="100" step="1" class="form-control" name="skew" id="skew" value="0" placeholder="Sklon svahu">
                    </div>
                </div>
                <div class="form-group">
                    <label for="wind" class="col-sm-3 control-label">Rychlost větru (km.h<sup>-1</sup>):</label>
                    <div class="col-sm-9">
                        <input type="number" min="0"  step="1" class="form-control" name="wind" id="wind" value="0" placeholder="Rychlost větru">
                    </div>
                </div>
                <div class="form-group">
                    <label for="delay" class="col-sm-3 control-label">Reakce řidiče (s):</label>
                    <div class="col-sm-9">
                        <input type="number" min="0"  step="0.01" class="form-control" name="delay" id="delay" value="0" placeholder="Reakce řidiče">
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-md-offset-3 col-md-9">
                        <input type="hidden" name="op" value="trail" />
                        <input type="hidden" name="break_koef" value="<?php echo $commander->getValue('avg_power')?>" />
                        <input type="hidden" name="whole_break" value="<?php echo ($commander->getValue('avg_pow_front_l') + $commander->getValue('avg_pow_front_p') + $commander->getValue('avg_pow_back_l') + $commander->getValue('avg_pow_back_p'))?>" />
                        <button class="btn btn-primary trail-call">Vypočítat</button>
                    </div>
                </div>
            </form>
            <div id="trail-response-wrapper">
            </div>
            </div>
            <?php endif;?>
        </div>
    </div>
</div>

<?php if ($check):?>
<script><?php echo $symmetry->getJs('front');?></script>
<script><?php echo $symmetry->getJs('back');?></script>
<script><?php echo $symmetry->getJs('hand');?></script>
<script><?php echo $power->getJs('front');?></script>
<script><?php echo $power->getJs('back');?></script>
<script><?php echo $symmetry->getJsPercent('front');?></script>
<script><?php echo $symmetry->getJsPercent('back');?></script>
<script><?php echo $symmetry->getJsPercent('hand');?></script>
<? endif;?>
<div id="infoModal" class="modal fade">
  <div class="modal-dialog">
    <div class="modal-content">
      <!-- dialog body -->
      <div class="modal-body">
        <button type="button" class="close" data-dismiss="modal">&times;</button>
        <?php echo $commander->getTimes('html'); ?>
      </div>
      <!-- dialog buttons -->
      <div class="modal-footer"><button type="button" class="btn btn-primary" data-dismiss="modal">OK</button></div>
    </div>
  </div>
</div>

</body>
</html>